<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="static/style.css">
</head>
<body>
    <div class="container">
        <div class="room">
            <label for="room">Room:</label>
            <input id="room" name="room" type="text">
            <button onclick="joinRoom()" >Join</button>
        </div>
        <div class="messages">
            <label for="messages">Message</label>
            <input id="message" type="text">
            <button onclick="sendMessage()">Send</button>
        </div>
        <div class="broadcast">
            <label for="broadcast">Message for broadcast:</label>
            <input id="broadcast" type="text">
            <button onclick="sendMessageBroadcast()" >Broadcast</button>
        </div>
    </div>

    <div class="logs">
        <ul id="logs">
        
        </ul>
    </div>

    <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/4.0.1/socket.io.js" integrity="sha512-q/dWJ3kcmjBLU4Qc47E4A9kTB4m3wuTY7vkFJDTZKjTs8jhyGQnaUrxa0Ytd0ssMZhbNua9hE+E7Qv1j+DyZwA==" crossorigin="anonymous"></script>
    <script type="text/javascript" charset="utf-8">
        var room_user = undefined;
        var socket = io("127.0.0.1:5000");
        socket.on('connect', function() {
            socket.emit('json', {data: 'I\'m connected!'});
        });

        let help = {
            "log":(msg)=>{
                $("#logs").append("<li>Notification: "+msg.message + "</li>")
            }
        }

        socket.on('join_response', function(msg, cb) {
            help.log(msg)

            if(cb){
                cb()
            }

        });

        socket.on('message_response', function(msg, cb) {
            help.log(msg)

            if(cb){
                cb()
            }

        });

        socket.on('broadcast_response', function(msg, cb) {
            help.log(msg)

            if(cb){
                cb()
            }

        });

        
        function joinRoom() {
            var room = document.getElementById("room").value
            room_user = room
            
            socket.emit('join', {room: room});
        }

        function sendMessage() {
            var message = document.getElementById("message").value
            socket.emit("message", {message:message, room:room_user})
        }

        function sendMessageBroadcast() {
            var message = document.getElementById("broadcast").value
            socket.emit("broadcast", {message:message})
        }
    
    </script>
</body>
</html>